// C program to sort an array using bucket sort
#include "Bucket.h"
#include "Insertion.h"

// A utility function to get maximum value in arr[]
static int getMax(int arr[], int n)
{
    int max = arr[0];
    for (int i = 1; i < n; i++)
        if (arr[i] > max)
            max = arr[i];
    return max;
}
// Function to sort arr[] of size using bucket sort
void bucketSort(int *arr, int arraySize)
{
    Bucket_t buckets[arraySize+1];
	int max = getMax(arr, arraySize);

	for(int i = 0; i < (arraySize+1); ++i)
	{
		buckets[i].size = 0;
		buckets[i].items = NULL;
	}
    // 2) Put array elements in different buckets
    for (int i = 0; i < arraySize; i++)
	{
        int bi = arraySize * (arr[i]/(double)max); // Index in bucket
		int bucketSize = buckets[bi].size;
		buckets[bi].items = (int*) realloc(buckets[bi].items, sizeof(int)*(bucketSize+1));
        buckets[bi].items[bucketSize] = arr[i];
		buckets[bi].size = bucketSize+1;
    }

    // 3) Sort individual buckets
    for (int i = 0; i < (arraySize+1); i++)
        insertionSort(buckets[i].items, buckets[i].size);

    // 4) Concatenate all buckets into arr[]
    int index = 0;
    for (int i = 0; i < (arraySize+1); i++)
        for (int j = 0; j < buckets[i].size; j++)
			arr[index++] = buckets[i].items[j];
}
