#include "Counting.h"

#define MAXVALUES 10000

void countSort(int *input, int size)
{
    // The output array that will have sorted input
    int *output;
	output = (int*) malloc(sizeof(int)*size);

    // Create a count array to store count of inidividul
    // items and initialize count array as 0
    int count[MAXVALUES+1];
    for(int i = 0; i <= MAXVALUES; ++i)
        count[i] = 0;

    // Store count of each character
    for (int i = 0; i < size; ++i)
        ++count[input[i]];

    // Change count[i] so that count[i] now contains actual
    // position of this character in output array
    for (int i = 1; i <= MAXVALUES; ++i)
        count[i] += count[i - 1];

    // Build the output character array
    for (int i = 0; i < size; ++i) {
        output[count[input[i]] - 1] = input[i];
        --count[input[i]];
    }

    /*
     For Stable algorithm
     for (i = sizeof(input)-1; i>=0; --i)
    {
        output[count[input[i]]-1] = input[i];
        --count[input[i]];
    }

    For Logic : See implementation
    */

    // Copy the output array to arr, so that arr now
    // contains sorted characters
    for (int i = 0; i < size; ++i)
        input[i] = output[i];
}
